package config

import (
	"io/ioutil"

	"gopkg.in/validator.v2"

	yaml "gopkg.in/yaml.v2"
)

type Config struct {
	MetricsFrequency int    `yaml:"metrics_frequency"`
	Password         string `yaml:"password"`
	Username         string `yaml:"username"`
}

func LoadFromFile(filepath string, object interface{}) error {
	contents, err := ioutil.ReadFile(filepath)
	if err != nil {
		return err
	}

	if err := yaml.Unmarshal(contents, object); err != nil {
		return err
	}

	err = validator.Validate(object)

	return err
}
