package metrics_test

import (
	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
	. "github.com/pivotal-cf-experimental/mysql-metrics/metrics"
	. "github.com/pivotal-cf-experimental/mysql-metrics/metrics/metricsfakes"
)

var _ = Describe("MetricWriter", func() {
	var (
		metric       Metric
		key          string
		value        float64
		unit         string
		metricWriter *MetricWriter
	)
	It("send metric ", func() {
		fakeSender := new(FakeSender)
		metricWriter = NewMetricWriter(fakeSender)
		key = "metrics-key"
		value = 123.5
		unit = "unit"
		metric = Metric{Key: key, Value: value, Unit: unit}
		metricWriter.Write(&metric)
		Expect(fakeSender.SendValueCallCount()).To(Equal(1))
		keyArg, valueArg, unitArg := fakeSender.SendValueArgsForCall(0)
		Expect(keyArg).To(Equal(key))
		Expect(valueArg).To(Equal(value))
		Expect(unitArg).To(Equal(unit))
	})
})
