// This file was generated by counterfeiter
package canaryfakes

import (
	"sync"
	"time"

	"github.com/pivotal-cf-experimental/replication-canary/canary"
	"github.com/pivotal-cf-experimental/replication-canary/models"
)

type FakeChirper struct {
	ChirpStub        func(conns []*models.NamedConnection, writeConn *models.NamedConnection, timestamp time.Time) (bool, error)
	chirpMutex       sync.RWMutex
	chirpArgsForCall []struct {
		conns     []*models.NamedConnection
		writeConn *models.NamedConnection
		timestamp time.Time
	}
	chirpReturns struct {
		result1 bool
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeChirper) Chirp(conns []*models.NamedConnection, writeConn *models.NamedConnection, timestamp time.Time) (bool, error) {
	var connsCopy []*models.NamedConnection
	if conns != nil {
		connsCopy = make([]*models.NamedConnection, len(conns))
		copy(connsCopy, conns)
	}
	fake.chirpMutex.Lock()
	fake.chirpArgsForCall = append(fake.chirpArgsForCall, struct {
		conns     []*models.NamedConnection
		writeConn *models.NamedConnection
		timestamp time.Time
	}{connsCopy, writeConn, timestamp})
	fake.recordInvocation("Chirp", []interface{}{connsCopy, writeConn, timestamp})
	fake.chirpMutex.Unlock()
	if fake.ChirpStub != nil {
		return fake.ChirpStub(conns, writeConn, timestamp)
	} else {
		return fake.chirpReturns.result1, fake.chirpReturns.result2
	}
}

func (fake *FakeChirper) ChirpCallCount() int {
	fake.chirpMutex.RLock()
	defer fake.chirpMutex.RUnlock()
	return len(fake.chirpArgsForCall)
}

func (fake *FakeChirper) ChirpArgsForCall(i int) ([]*models.NamedConnection, *models.NamedConnection, time.Time) {
	fake.chirpMutex.RLock()
	defer fake.chirpMutex.RUnlock()
	return fake.chirpArgsForCall[i].conns, fake.chirpArgsForCall[i].writeConn, fake.chirpArgsForCall[i].timestamp
}

func (fake *FakeChirper) ChirpReturns(result1 bool, result2 error) {
	fake.ChirpStub = nil
	fake.chirpReturns = struct {
		result1 bool
		result2 error
	}{result1, result2}
}

func (fake *FakeChirper) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.chirpMutex.RLock()
	defer fake.chirpMutex.RUnlock()
	return fake.invocations
}

func (fake *FakeChirper) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ canary.Chirper = new(FakeChirper)
